<template>
  <div>
    <div
      v-if="!isNew"
      class="row mb30"
    >
      <div class="col-xs-6">
        <ObDatePickerConstructor
          :value="getValueFromPath(dataSource, 'eventData.occurredAt')"
          label="Дата и время создания"
          :is-time="true"
          :readonly="true"
        />
      </div>
      <div class="col-xs-6">
        <ObInput
          label="Инициатор события"
          :value="getValueFromPath(dataSource, 'eventData.authorTitle')"
          :readonly="true"
        />
      </div>
    </div>
    <div
      v-if="isNew"
      class="row mb30"
    >
      <div class="col-xs-6">
        <ObInput
          label="Грузоотправитель"
          :value="getValueFromPath(formData, keys.consignorTitle)"
          :readonly="true"
        />
      </div>
      <div class="col-xs-6">
        <ObSelect
          label="Номер заказа перевозчика"
          placeholder="Выберите из списка"
          :value="getValueFromPath(formData, keys.suborderUuid)"
          :items="dataSource.suborders || []"
          :readonly="isSubordersSelectDisabled"
          display-exp="number"
          @selected="onSelectSuborder"
        />
      </div>
    </div>
    <div
      v-if="isNew"
      class="row mb30"
    >
      <div class="col-xs-6">
        <ObInput
          label="Водитель"
          :value="getValueFromPath(formData, keys.driverFio)"
          placeholder="ー"
          :readonly="true"
        />
      </div>
      <div class="col-xs-6">
        <ObInput
          label="Телефон"
          :value="getValueFromPath(formData, keys.driverPhone)"
          mask="+7 (999) 999-9999"
          :readonly="true"
        />
      </div>
    </div>
    <div
      v-if="isNew"
      class="row mb10"
    >
      <div class="col-xs-12">
        <ObInput
          label="Материальные ценности"
          :value="getValueFromPath(formData, 'materialValues')"
          placeholder="ー"
          :readonly="!isNew || !formData.suborderUuid"
          @input="onChangeField(keys.materialValues, $event)"
        />
      </div>
    </div>
    <div
      v-if="isNew"
      class="d-f mb30"
    >
      <ObStepper
        label="Количество"
        :model-value="getValueFromPath(formData, keys.unitValue)"
        :readonly="!isNew || !formData.suborderUuid"
        :min-value="0"
        :max-value="'infinity'"
        class="input-unit"
        @input="onChangeField(keys.unitValue, $event)"
      />
      <ObInput
        label="Ед. измерения"
        :value="getValueFromPath(formData, keys.unitTitle)"
        :readonly="!isNew || !formData.suborderUuid"
        placeholder="ー"
        class="input-unit"
        @input="onChangeField(keys.unitTitle, $event)"
      />
    </div>
    <div
      v-if="isNew || isEditMode || getValueFromPath(formData, keys.comment)"
      class="row"
    >
      <div class="col-xs-12">
        <ObTextarea
          :value="getValueFromPath(formData, keys.comment)"
          label="Комментарий"
          placeholder="Добавьте комментарий"
          :readonly="!isNew && !isNewForm"
          @input="onChangeField(keys.comment, $event)"
        />
      </div>
    </div>
    <template v-if="!currentFiles.length && isEditMode && !isNewForm">
      <div class="title">Нет прикрепленных файлов</div>
    </template>
    <template v-if="currentFiles.length || isNew || isNewForm">
      <div class="title">Прикрепленные файлы</div>
      <ObUploader
        ref="uploader"
        multiple
        :value="currentFiles()"
        data-qa="uploader"
        :is-read-only="!isNew && !isNewForm"
        :upload-method="uploadMethod"
        @process-start="startUploadFiles"
        @change="onUploadHandler"
      />
    </template>
  </div>
</template>

<script>
import api from "@/api"
import ObInput from 'common-components/src/obComponents/obInput'
import ObSelect from 'common-components/src/obComponents/obSelect'
import ObTextarea from 'common-components/src/obComponents/obTextarea'
import ObStepper from 'common-components/src/obComponents/obStepper'
import ObDatePickerConstructor from 'common-components/src/obComponents/obDatePickerConstructor'
import ObUploader from 'common-components/src/obComponents/obUploader'
import { getValueFromPath } from 'common-components/src/helpers/common'

export default {
  name: 'AttorneyLettersChangeForm',
  components: {
    ObInput,
    ObSelect,
    ObTextarea,
    ObStepper,
    ObUploader,
    ObDatePickerConstructor,
  },
  props: {
    formData: {
      type: Object,
      default: () => {}
    },
    isEditMode: {
      type: Boolean,
      default: false
    },
    isNew: {
      type: Boolean,
      default: false
    },
    isNewForm: {
      type: Boolean,
      default: false
    },
    dataSource: {
      type: Object,
      default: () => {}
    },
    order: {
      type: Object,
      default: () => {}
    }
  },
  data () {
    return {

    }
  },
  watch: {
    'dataSource.suborders': {
      immediate: true,
      handler (suborders) {
        if (suborders?.length === 1) {
          this.onSelectSuborder(suborders[0])
        }
      }
    },
    currentFiles (value) {
      if (!value || !value.length) {
        this.$refs.uploader && this.$refs.uploader.clearFiles()
      }
    }
  },
  computed: {
    keys () {
      return {
        orderUuid: this.isNew ? 'orderUuid' : 'specialParameters.orderUuid',
        suborderUuid: this.isNew ? 'suborderUuid' : 'specialParameters.suborderUuid',
        consignorTitle: this.isNew ? 'consignor.title' : 'specialParameters.consignor.title',
        driverFio: this.isNew ? 'driver.fio' : 'specialParameters.driver.fio',
        driverPhone: this.isNew ? 'driver.phone' : 'specialParameters.driver.phone',
        driverUuid: this.isNew ? 'driver.uuid' : 'specialParameters.driver.uuid',
        materialValues: this.isNew ? 'materialValues' : 'specialParameters.materialValues',
        unitTitle: this.isNew ? 'unitTitle' : 'specialParameters.unitTitle',
        unitValue: this.isNew ? 'unitValue' : 'specialParameters.unitValue',
        comment: this.isNew ? 'comment' : 'eventData.comment',
        fileUuids: this.isNew ? 'fileUuids' : 'eventData.fileUuids'
      }
    },
    uploadMethod () {
      return api.files.postFile
    },
    isSubordersSelectDisabled () {
      return this.dataSource?.suborders?.length === 1
    }
  },
  methods: {
    currentFiles () {
      return this.dataSource?.filesData || this.formData?.filesData || []
    },
    getValueFromPath (data, path) {
      return getValueFromPath({ data, path })
    },
    startUploadFiles () {
      this.formData.fileUuids = 'loading'
    },
    async onUploadHandler (data) {
      data = data.map(file => file.uuid)

      if (!data || !data.length) {
        this.onChangeField(this.keys.fileUuids, null)
        return
      }

      this.onChangeField(this.keys.fileUuids, data)
    },
    onChangeField (path, value) {
      this.$emit('change-field', { path, value })
    },
    async getSuborderData (data) {
      if (data.uuid !== this.formData.suborderUuid) {
        this.suborderData = await api.orderProcess.getSubOrder({
          data,
          orderUuid: this.order.uuid,
          isClient: false
        })
      }
    },
    async onSelectSuborder (data) {
      const isGetData = data.uuid !== this.getValueFromPath(this.formData, this.keys.suborderUuid)
      this.onChangeField(this.keys.suborderUuid, data.uuid)

      if (isGetData) {
        const res = await api.orderProcess.getAttorneyLettersInfo({
          orderUuid: this.formData.orderUuid,
          suborderUuid: data.uuid
        })

        const { driver, materialValues, unitTitle, unitValue, files } = res || {}

        if (files?.length) {
          const fileData = await api.files.getFile(files[0])

          this.onChangeField('filesData', [
            {
              uuid: files[0],
              file: {
                name: fileData.name
              },
              isUploaded: true
            }
          ])
          this.onChangeField('fileUuids', files)
        }

        this.onChangeField(this.keys.driverFio, driver?.fio)
        this.onChangeField(this.keys.driverPhone, driver?.phone)
        this.onChangeField(this.keys.driverUuid, driver?.uuid)
        this.onChangeField(this.keys.materialValues, materialValues)
        this.onChangeField(this.keys.unitTitle, unitTitle)
        this.onChangeField(this.keys.unitValue, unitValue)
      }
    },
    submitForm () {
      this.$emit('submit-form')
    }
  }
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

.row-input {
  margin-right: 0;
  margin-left: 0;
  flex-wrap: nowrap;
  &__item {
    width: 212px;
    flex-grow: 2;
    &:not(:last-child) {
      margin-right: 10px;
    }
  }
  &__counter {
    width: 135px;
  }
}

.mb10 {
  margin-bottom: 10px!important;
}

.mt10 {
  margin-top: 10px!important;
}

.mb30 {
  margin-bottom: 30px!important;
}

.mt0 {
  margin-top: 0!important;
}

.input-unit {
  width: 150px!important;
  & + .input-unit {
    margin-left: 10px;
  }
}
</style>
